////////////////////////////////////////////////////////////////////////////////////
//reelle x-Achse der Mandelbrotmenge entspricht log. Wachstum (Feigenbaum-Diagramm)
////////////////////////////////////////////////////////////////////////////////////

ArrayList<Threads> threads;
double xU = 1; 
double yU = -0.05; 
double xO = 4;
double yO = 2.95;
double zoomFaktor=1;
double wh = xO-xU;
double D;
int maxiterations = 1024;//
double massFuerUnendlich = 10000;//auch hier
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
boolean feigenbaumZeichnen = false;
int NF, LF;
float fU = 0; //Wertebereich Feigenbaum
float fO = 0;
float d; //Schrittweite für Feigenbaum
float fAlt, fNeu;
float frK; // r-Koordinate 
float fyK; //y-Koordinaten Feigenbaum
float r; //Parameter für logistisches Wachstum


void setup() {
  size(800, 800);
  background(255);
  //noLoop();
  colorMode(RGB);
  threads = new  ArrayList<Threads>(); 
  fU = 0; 
  fO = 1;
  NF= 800; //Anzahl Iterationen Feigenbaum
  LF =500; //Feigenbaum ab hier gerechnet
  d =(float) (xO-xU)/4000; //Schrittweite 
  r =(float) xU;
  nummerThread =0;
  //println("Anzahl Threads: "+anzahlThreads);
// starte anzahlThreads Threads
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  
}

/////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer){
  
  xU = px; yU = py;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;//println(wh/anzahlThreads); double y= yU;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread);
        //println(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
  }  
}
//////////////////////////////////////////////////////////////
void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 if(!feigenbaumZeichnen){
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);
   
  }  
 }
  if(feigenbaumZeichnen){
      stroke(255); strokeWeight(2);
      if (r<xO) r = r+d;
      iteriereF(r);
      
  }   
}
//////////////////////////////////////////////////////////
//Feigenbaum-Iteration
////////////////////////////////////////////////////////
void iteriereF(float r) {  
  stroke(255,0,0);//println("iteriere");
  strokeWeight(1);
  fAlt = 0.5; //Startwert
  frK = map(r,(float)xU, (float)xO, 0, width);      
  int i=0;
  while (i <=NF) {
    fNeu = r*fAlt*(1-fAlt);
    if (i > LF && abs(fNeu) < 10) {
      fyK = map(fNeu, fU, fO, height, 0);   
      point(frK, fyK);  
    }
    fAlt = fNeu;
    i++;
  }
  stroke(0);
  strokeWeight(1.2);
 
}

/////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
      //println((xO-xU)/2);
     // berechne, wo der Mauszeiger im gezeigten Ausschnitt der komplexen
     // Zahlenebene ist (Transformation Pixelposition nach (x,y))
      xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
      xU = xUNeu; xO = xONeu; 
     // println((xO-xU)/2);
      yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
      yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
      yU =yUNeu; yO = yONeu; 
      wh = wh/5;
      zoomFaktor =zoomFaktor*5;
      println("Zoomfaktor: "+zoomFaktor);
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);

     redraw();
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  if (key == 'f'){
     r =(float) xU;
     d = d/5;
     feigenbaumZeichnen = true;
     println("Feigenbaum eintragen" );   
  }
   if (key == 'w'){
     feigenbaumZeichnen = false;
     println("Feigenbaum gelöscht" );   
  }
  if (key == '+'){
     nummerThread =0;
     background(0);
     maxiterations *= 1.2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == '-') {
      nummerThread =0;
      background(0);
      maxiterations /= 1.2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);  
  }
   if (key == 'z'){
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     background(0);
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 'l'){
     nummerThread =0;
     background(0);
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 'r'){
     nummerThread =0;
     background(0);
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
   if (key == 'u'){
     nummerThread =0;
     background(0);
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 'o'){
     nummerThread =0;
     background(0);
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread);
  }
  if (key == 's') save("mandelbrot.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
